require 'xfers'

Xfers.set_api_key 'G-zsfAEScrqdU8GhWTEdjfdnb3XRdU8q1fH-nuWfSzo'
Xfers.set_sg_sandbox

begin
  puts 'Adding bank account...'
  params = {
      'account_no'=> '12988012511',
      'bank'=> 'OCBC'
  }
  bank_accounts = Xfers::BankAccount.add params
  puts "number of bank accounts=> #{bank_accounts.length}"
  bank_accounts.each { |account| puts "Bank Account=> #{account}" }
rescue Xfers::XfersError => e
  puts e.to_s
end

begin
  puts 'Adding bank account...'
  params = {
      'account_no'=> '03931234321',
      'bank'=> 'DBS'
  }
  bank_accounts = Xfers::BankAccount.add params
  puts "number of bank accounts=> #{bank_accounts.length}"
  bank_accounts.each { |account| puts "Bank Account=> #{account}" }
rescue Xfers::XfersError => e
  puts e.to_s
end

begin
  puts 'Listing all bank accounts...'
  bank_accounts = Xfers::BankAccount.list_all
  puts "number of bank accounts=> #{bank_accounts.length}"
  bank_accounts.each { |account| puts "Bank Account=> #{account}" }
rescue Xfers::XfersError => e
  puts e.to_s
end


begin
  puts 'Deleting bank account...'
  resp = Xfers::BankAccount.delete '21'
  puts resp
rescue Xfers::XfersError => e
  puts e.to_s
end

begin
  params = {
      'account_no'=> '209367835',
      'bank'=> 'POSB'
  }
  puts 'Updating bank account...'
  resp = Xfers::BankAccount.update '22', params
  puts resp
rescue Xfers::XfersError => e
  puts e.to_s
end

begin
  puts 'Withdrawing from bank account...'
  params = {
      'amount'=> '20',
      'express'=> 'false'
  }
  resp = Xfers::BankAccount.withdraw '22', params
  puts resp
rescue Xfers::XfersError => e
  puts e.to_s
end

begin
  puts 'Listing withdrawal requests...'
  params = {
      'filter'=> 'pending'
  }
  withdrawal_requests = Xfers::BankAccount.withdrawal_requests params
  withdrawal_requests.each { |req| puts "Withdrawal request=> #{req}" }
rescue Xfers::XfersError => e
  puts e.to_s
end
