require 'xfers'

Xfers.set_api_key 'WuTp3zM7UEpmUkeAyGPxRHmnXAx-hXJ7jzdqmxY6S1o'
Xfers.set_sg_sandbox

# Get the following user_api_token from http://docs.xfers.io/#xfers-connect
# you should have one user_api_token for every user you wish to add a credit card to.
user_api_token = 'osEdbc8uzxY5vaXA-oe-7E86sVWCYTCVPuHQyFQ-uPQ'

begin
  puts 'Listing all cards...'
  params = {
      'limit'=> '5'
  }
  cards = Xfers::Card.list_all user_api_token
  cards.each { |card|
    puts card
  }
rescue Xfers::XfersError => e
  puts e.to_s
end

begin
  puts 'Adding card...'
  params = {
      'user_api_token' => user_api_token,
      'credit_card_token' => 'tok_19GiimB8MXWbQJDjF8FUIgpA', # gotten from http://docs.xfers.io/#xfers-tokenize
      'first6' => '424242',
      'last4' => '4242'
  }
  resp = Xfers::Card.add params
  puts resp
rescue Xfers::XfersError => e
  puts e.to_s
end

begin
  puts 'Deleting card'
  card_id = 'card_19C2JSI7jGeCrIKD0nVdiCHp'
  resp = Xfers::Card.delete card_id, user_api_token
  puts resp
rescue Xfers::XfersError => e
  puts e.to_s
end

begin
  puts 'Setting default card'
  card_id = 'card_196iRQI7jGeCrIKDl5hrCmxE'
  resp = Xfers::Card.set_default card_id, user_api_token
  puts resp
rescue Xfers::XfersError => e
  puts e.to_s
end

begin
  puts 'Charge guest card'
  charge_id = '54539f543f33456a98495bda4bc33abe'
  params = {
      'txn_id' => charge_id,
      'credit_card_token' => 'tok_19GijKB8MXWbQJDjKCniMsgn', # gotten from http://docs.xfers.io/#xfers-tokenize
      'first6' => '424242',
      'last4' => '4242'
  }
  resp = Xfers::Card.charge_guest params
  puts resp
rescue Xfers::XfersError => e
  puts e.to_s
end

begin
  puts 'Charge existing card'
  charge_id = '9cfaac1c8d8a47d18540a87f4c1e711b'
  resp = Xfers::Card.charge_existing charge_id
  puts resp
rescue Xfers::XfersError => e
  puts e.to_s
end
