require 'xfers'

Xfers.set_api_key 'WuTp3zM7UEpmUkeAyGPxRHmnXAx-hXJ7jzdqmxY6S1o'
Xfers.set_sg_sandbox

charge_id = ''

begin
  puts 'Listing all charges...'
  params = {
      'limit'=> '5'
  }
  charges = Xfers::Charge.list_all params
  charges.each { |charge|
    puts charge
  }
rescue Xfers::XfersError => e
  puts e.to_s
end

begin
  puts 'Creating charge...'
  params = {
      'redirect' => 'false',
      'amount' => '9.99',
      'currency' => 'SGD',
      'notify_url' => 'https://mysite.com/payment_notification',
      'return_url' => 'https://mysite.com/return',
      'cancel_url' => 'https://mysite.com/cancel',
      'order_id' => 'AZ9912',
      'description' => 'unused red dress',
      'shipping' => '2.50',
      'tax' => '0.0',
      'items' => [{'description' => 'Red dress Size M', 'price' => '9.99', 'quantity' => 1, 'name' => 'Red dress'}],
      'meta_data' => {'firstname'=> 'Tianwei', 'lastname'=> 'Liu'}
  }
  resp = Xfers::Charge.create params
  charge_id = resp[:id]
  puts resp
rescue Xfers::XfersError => e
  puts e.to_s
end

begin
  puts "Retrieving charge... #{charge_id}"
  resp = Xfers::Charge.retrieve charge_id
  puts resp
rescue Xfers::XfersError => e
  puts e.to_s
end

begin
  params = {
      'currency'=> 'SGD',
      'order_id'=> 'A01231z2',
      'total_amount'=> '1.99',
      'status'=> 'unclaimed'
  }
  puts "Validating charge... #{charge_id}"
  resp = Xfers::Charge.validate charge_id, params
  puts resp
rescue Xfers::XfersError => e
  puts e.to_s
end

begin
  puts "Cancelling charge... #{charge_id}"
  resp = Xfers::Charge.cancel charge_id
  puts resp
rescue Xfers::XfersError => e
  puts e.to_s
end

begin
  charge_id = 'your-charge-id'
  puts "Refunding charge... #{charge_id}"
  resp = Xfers::Charge.refund charge_id
  puts resp
rescue Xfers::XfersError => e
  puts e.to_s
end

begin
  charge_id = 'your-charge-id'
  auth_code = '012414'
  puts "Authorizing charge... #{charge_id}"
  resp = Xfers::Charge.authorize charge_id, auth_code
  puts resp
rescue Xfers::XfersError => e
  puts e.to_s
end
