require 'xfers'

Xfers.set_api_key 'G-zsfAEScrqdU8GhWTEdjfdnb3XRdU8q1fH-nuWfSzo'
Xfers.set_sg_sandbox

begin
  puts 'Retrieving user...'
  resp = Xfers::User.retrieve
  puts resp[:first_name]
  puts resp[:last_name]
  puts resp[:available_balance]
  puts resp
rescue Xfers::XfersError => e
  puts e.to_s
end

begin
  puts 'Updating user...'
  params = {
      'first_name'=>'Tommy',
      'last_name'=>'Tan',
      'email'=>'jelly@xfers.io',
      'date_of_birth'=>'1986-02-27',
      'address_line_1'=>'Blk 608 Pasir Ris',
      'address_line_2'=>'#08-41',
      'nationality'=>'Singaporean',
      'postal_code'=>'510608',
      'identity_no'=>'S8692038G',
      'id_front_url'=>'http://angelsgateadvisory.sg/wp-content/uploads/2015/10/Logo.jpg',
      'id_back_url'=>'http://angelsgateadvisory.sg/wp-content/uploads/2015/10/Logo.jpg',
      'selfie_2id_url'=>'http://angelsgateadvisory.sg/wp-content/uploads/2015/10/Logo.jpg',
      'proof_of_address_url'=>'http://angelsgateadvisory.sg/wp-content/uploads/2015/10/Logo.jpg',
      'meta_data'=>'foobar'
  }
  resp = Xfers::User.update params
  puts resp[:first_name]
  puts resp[:last_name]
  puts resp[:available_balance]
  puts resp
rescue Xfers::XfersError => e
  puts e.to_s
end

begin
  puts 'Getting transfer info...'
  resp = Xfers::User.transfer_info
  puts resp
rescue Xfers::XfersError => e
  puts e.to_s
end

begin
  puts 'Getting activities...'
  activities = Xfers::User.activities
  activities.each { |activity|
    puts activity
  }
rescue Xfers::XfersError => e
  puts e.to_s
end