$:.unshift(File.join(File.dirname(__FILE__), 'lib'))

require 'xfers/version'

spec = Gem::Specification.new do |gem|
  gem.name = 'xfers'
  gem.version = Xfers::VERSION
  gem.required_ruby_version = '>= 2.0.0'
  gem.summary = 'Ruby bindings for the Xfers API'
  gem.description = 'Xfers is the easiest way to accept payments online in South East Asia.  See https://xfers.com for details.'
  gem.author = 'Xfers'
  gem.email = 'support@xfers.io'
  gem.homepage = 'http://docs.xfers.io'
  gem.license = 'MIT'

  gem.add_runtime_dependency('rest-client', '~> 2.0')

  gem.files = `git ls-files`.split("\n")
  gem.executables   = `git ls-files -- bin/*`.split("\n").map{ |f| File.basename(f) }
  gem.require_paths = ['lib']
end
